glibmm: Glib::Cond Class Reference

glibmm 2.29.13

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# Glib::Cond Class Reference
Threads

An opaque data structure to represent a condition. More...

`#include <glibmm/thread.h>`

List of all members.

## Public Member Functions
| Cond ()
| ~Cond ()
void | signal ()
| If threads are waiting for this Cond, exactly one of them is woken up.
void | broadcast ()
| If threads are waiting for this Cond, all of them are woken up.
void | wait (Mutex& mutex)
| Waits until this thread is woken up on this Cond.
bool | timed_wait (Mutex& mutex, const Glib::TimeVal& abs_time)
| Waits until this thread is woken up on this Cond, but not longer than until the time, that is specified by abs_time.
GCond* | gobj ()

## Detailed Description

An opaque data structure to represent a condition.

A Cond is an object that threads can block on, if they find a certain condition to be false. If other threads change the state of this condition they can signal the Cond, such that the waiting thread is woken up.

Usage example:

       Glib::Cond data_cond;
       Glib::Mutex data_mutex;
       void* current_data = 0;

       void push_data(void* data)
       {
         Glib::Mutex::Lock lock (data_mutex);

         current_data = data;
         data_cond.signal();
       }

       void* pop_data()
       {
         Glib::Mutex::Lock lock (data_mutex);

         while (!current_data)
           data_cond.wait(data_mutex);

         void *const data = current_data;
         current_data = 0;

         return data;
       }

Examples:

  thread/thread.cc.

## Constructor & Destructor Documentation

Glib::Cond::Cond | ( |  | ) |

Glib::Cond::~Cond | ( |  | ) |

## Member Function Documentation

void Glib::Cond::broadcast | ( |  | ) |

If threads are waiting for this Cond, all of them are woken up.

It is good practice to hold the same lock as the waiting thread, while calling this method, though not required.

Note:
  This method can also be used if Glib::thread_init() has not yet been called and will do nothing then.

GCond* Glib::Cond::gobj | ( |  | ) | `[inline]`

void Glib::Cond::signal | ( |  | ) |

If threads are waiting for this Cond, exactly one of them is woken up.

It is good practice to hold the same lock as the waiting thread, while calling this method, though not required.

Note:
  This method can also be used if Glib::thread_init() has not yet been called and will do nothing then.

bool Glib::Cond::timed_wait | ( | Mutex& | mutex,
|  | const Glib::TimeVal& | abs_time
| ) |  |

Waits until this thread is woken up on this Cond, but not longer than until the time, that is specified by abs_time.

The mutex is unlocked before falling asleep and locked again before resuming.

This function can also be used, if Glib::thread_init() has not yet been called and will immediately return `true` then.

Parameters:

  mutex | a Mutex that is currently locked.
  abs_time | a max time to wait.

Note:
  It is important to use the wait() and timed_wait() methods only inside a loop, which checks for the condition to be true as it is not guaranteed that the waiting thread will find it fulfilled, even if the signaling thread left the condition in that state. This is because another thread can have altered the condition, before the waiting thread got the chance to be woken up, even if the condition itself is protected by a Mutex.

void Glib::Cond::wait | ( | Mutex& | mutex | ) |

Waits until this thread is woken up on this Cond.

The mutex is unlocked before falling asleep and locked again before resuming.

This method can also be used if Glib::thread_init() has not yet been called and will immediately return then.

Parameters:

  mutex | a Mutex that is currently locked.

Note:
  It is important to use the wait() and timed_wait() methods only inside a loop, which checks for the condition to be true as it is not guaranteed that the waiting thread will find it fulfilled, even if the signaling thread left the condition in that state. This is because another thread can have altered the condition, before the waiting thread got the chance to be woken up, even if the condition itself is protected by a Mutex.